/**
 * License Agreement.
 *
 *  JBoss RichFaces - Ajax4jsf Component Library
 *
 * Copyright (C) 2007  Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */
package org.richfaces.realworld.manager;

import java.io.Serializable;
import java.util.List;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Scope;
import org.richfaces.realworld.domain.Album;
import org.richfaces.realworld.service.IAlbumAction;
import org.richfaces.realworld.util.ConversationState;

@Name("albumManager")
@Scope(ScopeType.CONVERSATION)
public class AlbumManager implements Serializable{

	private static final long serialVersionUID = -1793632515385735086L;
	@In @Out
	private ConversationState conversationState;
	private List<Album> sharedAlbums;
	
	@In(create=true) IAlbumAction albumAction;
	
	public List<Album> getSharedAlbums(){
		if(null == sharedAlbums){
			sharedAlbums=albumAction.getSharedAlbums();
			conversationState.setSelectedAlbum(sharedAlbums.get(0));
			//conversationState.setSelectedImageIndex(1);
		}
		return sharedAlbums;
	}
	
	public void selectAlbum(Album a){
		conversationState.setSelectedAlbum(a);
		conversationState.setSelectedImage(null);
	}
	
	public void resetToAlbum(Album a){
		conversationState.setSelectedAlbum(a);
		conversationState.setSelectedImage(null);
	}
	
	public void selectImage(int index){
		conversationState.setSelectedImage(conversationState.getSelectedAlbum().getImages().get(index -1));
	}
}
